import { Enum, opcoesUFThfCombo, GlobalService, AuthModule, FndModule } from 'totvs-log-web-foundation';
import { Component, Input, ViewChild, NgModule } from '@angular/core';
import { Validators, FormBuilder, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { PoPageModule, PoFieldModule } from '@portinari/portinari-ui';
import { of } from 'rxjs';
import { concatMap, delay } from 'rxjs/operators';
import { cnpjValidator, inscricaoEstadualValidator, FormUtils, BaseMessage, ShowMessageType } from 'totvs-log-base-foundation';
import { UnidadeIncluirService } from 'totvs-log-base-foundation/src/sl-unidade';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UnidadeSegmentoEnum extends Enum {
    /**
     * @private
     * @param {?} value
     * @param {?} label
     * @param {?=} disabled
     */
    constructor(value, label, disabled = false) {
        super(value, label, disabled);
    }
    /**
     * @return {?}
     */
    static OPERADOR_LOGISTICO() {
        return new UnidadeSegmentoEnum('OPERADOR_LOGISTICO', 'operadorLogistico');
    }
    /**
     * @return {?}
     */
    static RECINTO_ADUANEIRO() {
        return new UnidadeSegmentoEnum('RECINTO_ADUANEIRO', 'operadorAduaneiro', true);
    }
    /**
     * @return {?}
     */
    static DISTRIBUIDOR() {
        return new UnidadeSegmentoEnum('DISTRIBUIDOR', 'distribuidor', false);
    }
    /**
     * @return {?}
     */
    static INDUSTRIA() {
        return new UnidadeSegmentoEnum('INDUSTRIA', 'industria', false);
    }
    /**
     * @return {?}
     */
    static VAREJO() {
        return new UnidadeSegmentoEnum('VAREJO', 'varejo', true);
    }
}
UnidadeSegmentoEnum.values = [
    UnidadeSegmentoEnum.OPERADOR_LOGISTICO(),
    UnidadeSegmentoEnum.RECINTO_ADUANEIRO(),
    UnidadeSegmentoEnum.DISTRIBUIDOR(),
    UnidadeSegmentoEnum.INDUSTRIA(),
    UnidadeSegmentoEnum.VAREJO()
];
if (false) {
    /** @type {?} */
    UnidadeSegmentoEnum.values;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class Unidade {
    constructor() { }
}
if (false) {
    /** @type {?} */
    Unidade.prototype.nome;
    /** @type {?} */
    Unidade.prototype.segmento;
    /** @type {?} */
    Unidade.prototype.cnpj;
    /** @type {?} */
    Unidade.prototype.unidadeFederativa;
    /** @type {?} */
    Unidade.prototype.inscricaoEstadual;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IUnidadeIncluirControle() { }
if (false) {
    /** @type {?} */
    IUnidadeIncluirControle.prototype.name;
    /** @type {?} */
    IUnidadeIncluirControle.prototype.validators;
    /** @type {?} */
    IUnidadeIncluirControle.prototype.get;
    /** @type {?} */
    IUnidadeIncluirControle.prototype.value;
    /** @type {?} */
    IUnidadeIncluirControle.prototype.withError;
}
/**
 * @record
 */
function IUnidadeIncluirControles() { }
if (false) {
    /** @type {?} */
    IUnidadeIncluirControles.prototype.nome;
    /** @type {?} */
    IUnidadeIncluirControles.prototype.segmento;
    /** @type {?} */
    IUnidadeIncluirControles.prototype.cnpj;
    /** @type {?} */
    IUnidadeIncluirControles.prototype.unidadeFederativa;
    /** @type {?} */
    IUnidadeIncluirControles.prototype.inscricaoEstadual;
}
class UnidadeIncluirForm {
    /**
     * @private
     * @param {?} formBuilder
     */
    constructor(formBuilder) {
        this.formBuilder = formBuilder;
        this._controles = {
            nome: this.criarControle('nome', Validators.required),
            segmento: this.criarControle('segmento', Validators.required),
            cnpj: this.criarControle('cnpj', cnpjValidator()),
            unidadeFederativa: this.criarControle('unidadeFederativa'),
            inscricaoEstadual: this.criarControle('inscricaoEstadual', inscricaoEstadualValidator((/**
             * @return {?}
             */
            () => this.controles.unidadeFederativa ? this.controles.unidadeFederativa.value() : '')))
        };
        this._grupo = this.formBuilder.group(this.criarControles());
        this.utils = new FormUtils(this.grupo);
    }
    /**
     * @return {?}
     */
    get controles() {
        return this._controles;
    }
    /**
     * @return {?}
     */
    get grupo() {
        return this._grupo;
    }
    /**
     * @param {?} formBuilder
     * @return {?}
     */
    static of(formBuilder) {
        return new UnidadeIncluirForm(formBuilder);
    }
    /**
     * @return {?}
     */
    formEstaValido() {
        /** @type {?} */
        const formValido = this.utils.executeFormValidation();
        return formValido && this.grupo.valid;
    }
    /**
     * @return {?}
     */
    getUnidadeIncluir() {
        return {
            id: undefined,
            nome: this.controles.nome.value(),
            cnpj: this.controles.cnpj.value(),
            inscricaoEstadual: this.controles.inscricaoEstadual.value(),
            unidadeFederativa: this.controles.unidadeFederativa.value(),
            segmento: this.controles.segmento.value()
        };
    }
    /**
     * @private
     * @return {?}
     */
    criarControles() {
        /** @type {?} */
        const controles = {};
        for (const chave in this.controles) {
            if (this.controles.hasOwnProperty(chave)) {
                controles[chave] = [null, this.controles[chave].validators];
            }
        }
        return controles;
    }
    /**
     * @private
     * @param {?} nome
     * @param {...?} validadores
     * @return {?}
     */
    criarControle(nome, ...validadores) {
        return {
            name: nome,
            validators: validadores,
            get: (/**
             * @return {?}
             */
            () => this.grupo ? this.grupo.get(nome) : null),
            value: (/**
             * @return {?}
             */
            () => this.grupo ? this.grupo.get(nome).value : null),
            withError: (/**
             * @param {?} error
             * @return {?}
             */
            (error) => (this.grupo.get(nome).dirty && this.grupo.get(nome).errors && this.grupo.get(nome).errors[error]))
        };
    }
}
if (false) {
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirForm.prototype._controles;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirForm.prototype._grupo;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirForm.prototype.utils;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirForm.prototype.formBuilder;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UnidadeIncluirComponent {
    /**
     * @param {?} global
     * @param {?} formBuilder
     * @param {?} router
     * @param {?} activatedRoute
     * @param {?} unidadeIncluirService
     */
    constructor(global, formBuilder, router, activatedRoute, unidadeIncluirService) {
        this.global = global;
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.unidadeIncluirService = unidadeIncluirService;
        this.esconderBotaoCancelar = false;
        this.rotaAposAcoes = './../';
        this._acoesPagina = [];
        this._opcoesEstado = opcoesUFThfCombo();
        this._opcoesSegmento = UnidadeSegmentoEnum.values.map((/**
         * @param {?} segmento
         * @return {?}
         */
        segmento => segmento.toSelect(this.global)));
        this._form = UnidadeIncluirForm.of(formBuilder);
    }
    /**
     * @return {?}
     */
    get acoesPagina() {
        return this._acoesPagina;
    }
    /**
     * @return {?}
     */
    get itensBreadcrumb() {
        return this._itensBreadcrumb;
    }
    /**
     * @return {?}
     */
    get form() {
        return this._form;
    }
    /**
     * @return {?}
     */
    get opcoesEstado() {
        return this._opcoesEstado;
    }
    /**
     * @return {?}
     */
    get opcoesSegmento() {
        return this._opcoesSegmento;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.definirAcoesPagina();
    }
    /**
     * @param {?} uf
     * @return {?}
     */
    alterarUnidadeFederativa(uf) {
        if (uf) {
            this.form.controles.inscricaoEstadual.get().reset();
            setTimeout((/**
             * @return {?}
             */
            () => {
                this.inscricaoEstadual.focus();
            }), 50);
        }
    }
    /**
     * @return {?}
     */
    definirAcoesPagina() {
        this._acoesPagina = [
            {
                label: this.global.i18n.literals.salvar,
                action: this.salvar.bind(this)
            }
        ];
        if (!this.esconderBotaoCancelar) {
            this._acoesPagina.push({
                label: this.global.i18n.literals.cancelar,
                action: this.cancelar.bind(this)
            });
        }
    }
    /**
     * @return {?}
     */
    salvar() {
        if (this.form.formEstaValido()) {
            this.global.loading.executeWithLoading((/**
             * @return {?}
             */
            () => this.unidadeIncluirService.Post(this.form.getUnidadeIncluir()))).pipe(concatMap((/**
             * @return {?}
             */
            () => of(null).pipe(delay(250))))).subscribe((/**
             * @return {?}
             */
            () => {
                this.global.msg.showMessage(new BaseMessage({
                    literal: 'unidadeIncluidaSucesso'
                }).withMessageType(ShowMessageType.NotificationSuccess));
                this.voltar();
            }), (/**
             * @param {?} error
             * @return {?}
             */
            (error) => {
                console.error(error);
            }));
        }
    }
    /**
     * @return {?}
     */
    cancelar() {
        this.voltar();
    }
    /**
     * @private
     * @return {?}
     */
    voltar() {
        this.router.navigate([this.rotaAposAcoes], {
            relativeTo: this.activatedRoute
        });
    }
}
UnidadeIncluirComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-unidade-incluir',
                template: "<po-page-default\n  [p-title]=\"global.i18n.literals['novaUnidade']\"\n  [p-actions]=\"acoesPagina\"\n  [p-breadcrumb]=\"itensBreadcrumb\">\n\n  <form \n    [formGroup]=\"form.grupo\"\n    class=\"po-row\">\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-input\n        [name]=\"form.controles.nome.name\"\n        [formControlName]=\"form.controles.nome.name\"\n        [p-label]=\"global.i18n.literals['nome']\"\n        [p-placeholder]=\"global.i18n.literals['informeNome']\"\n        p-focus>\n      </po-input>\n      <p\n        [hidden]=\"!form.controles.nome.withError('required')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['informeNome'] }}\n      </p>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-select\n        [name]=\"form.controles.segmento.name\"\n        [formControlName]=\"form.controles.segmento.name\"\n        [p-label]=\"global.i18n.literals['segmento']\"\n        [p-placeholder]=\"global.i18n.literals['selecioneSegmento']\"\n        [p-options]=\"opcoesSegmento\">\n      </po-select>\n      <p\n        [hidden]=\"!form.controles.segmento.withError('required')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['selecioneSegmento'] }}\n      </p>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-input\n        [name]=\"form.controles.cnpj.name\"\n        [formControlName]=\"form.controles.cnpj.name\"\n        [p-label]=\"global.i18n.literals['cnpj']\"\n        [p-placeholder]=\"global.i18n.literals['informeNumero']\"\n        p-mask=\"99.999.999/9999-99\"\n        p-optional>\n      </po-input>\n      <p\n        [hidden]=\"!form.controles.cnpj.withError('cnpjInvalido')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['cnpjInvalido'] }}\n      </p>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-select\n        [name]=\"form.controles.unidadeFederativa.name\"\n        [formControlName]=\"form.controles.unidadeFederativa.name\"\n        [p-label]=\"global.i18n.literals['estado']\"\n        [p-placeholder]=\"global.i18n.literals['selecioneEstado']\"\n        [p-options]=\"opcoesEstado\"\n        p-optional\n        (p-change)=\"alterarUnidadeFederativa($event)\">\n      </po-select>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-input\n        #inscricaoEstadual\n        [name]=\"form.controles.inscricaoEstadual.name\"\n        [formControlName]=\"form.controles.inscricaoEstadual.name\"\n        [p-label]=\"this.global.i18n.literals['inscricaoEstadual']\"\n        [p-placeholder]=\"this.global.i18n.literals['informeNumero']\"\n        [p-disabled]=\"!form.controles.unidadeFederativa.value()\"\n        p-mask=\"999999999999999\"\n        p-optional>\n      </po-input>\n      <p\n        [hidden]=\"!form.controles.inscricaoEstadual.withError('inscricaoEstadualInvalido')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['ieInvalido'] }}\n      </p>\n    </div>\n  </form>\n</po-page-default>\n",
                styles: [""]
            }] }
];
/** @nocollapse */
UnidadeIncluirComponent.ctorParameters = () => [
    { type: GlobalService },
    { type: FormBuilder },
    { type: Router },
    { type: ActivatedRoute },
    { type: UnidadeIncluirService }
];
UnidadeIncluirComponent.propDecorators = {
    esconderBotaoCancelar: [{ type: Input }],
    rotaAposAcoes: [{ type: Input }],
    inscricaoEstadual: [{ type: ViewChild, args: ['inscricaoEstadual', { static: true },] }]
};
if (false) {
    /** @type {?} */
    UnidadeIncluirComponent.prototype.esconderBotaoCancelar;
    /** @type {?} */
    UnidadeIncluirComponent.prototype.rotaAposAcoes;
    /** @type {?} */
    UnidadeIncluirComponent.prototype.inscricaoEstadual;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._acoesPagina;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._itensBreadcrumb;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._form;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._opcoesEstado;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._opcoesSegmento;
    /** @type {?} */
    UnidadeIncluirComponent.prototype.global;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype.router;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype.unidadeIncluirService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class UnidadeIncluirModule {
}
UnidadeIncluirModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    UnidadeIncluirComponent
                ],
                imports: [
                    CommonModule,
                    AuthModule,
                    FndModule,
                    FormsModule,
                    ReactiveFormsModule,
                    PoPageModule,
                    PoFieldModule
                ],
                exports: [
                    UnidadeIncluirComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { Unidade, UnidadeIncluirComponent, UnidadeIncluirForm, UnidadeIncluirModule, UnidadeSegmentoEnum };
//# sourceMappingURL=totvs-log-web-foundation-src-sl-unidade.js.map
