import { __extends } from 'tslib';
import { Enum, opcoesUFThfCombo, GlobalService, AuthModule, FndModule } from 'totvs-log-web-foundation';
import { Component, Input, ViewChild, NgModule } from '@angular/core';
import { Validators, FormBuilder, FormsModule, ReactiveFormsModule } from '@angular/forms';
import { Router, ActivatedRoute } from '@angular/router';
import { PoPageModule, PoFieldModule } from '@portinari/portinari-ui';
import { of } from 'rxjs';
import { concatMap, delay } from 'rxjs/operators';
import { cnpjValidator, inscricaoEstadualValidator, FormUtils, BaseMessage, ShowMessageType } from 'totvs-log-base-foundation';
import { UnidadeIncluirService } from 'totvs-log-base-foundation/src/sl-unidade';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UnidadeSegmentoEnum = /** @class */ (function (_super) {
    __extends(UnidadeSegmentoEnum, _super);
    function UnidadeSegmentoEnum(value, label, disabled) {
        if (disabled === void 0) { disabled = false; }
        return _super.call(this, value, label, disabled) || this;
    }
    /**
     * @return {?}
     */
    UnidadeSegmentoEnum.OPERADOR_LOGISTICO = /**
     * @return {?}
     */
    function () {
        return new UnidadeSegmentoEnum('OPERADOR_LOGISTICO', 'operadorLogistico');
    };
    /**
     * @return {?}
     */
    UnidadeSegmentoEnum.RECINTO_ADUANEIRO = /**
     * @return {?}
     */
    function () {
        return new UnidadeSegmentoEnum('RECINTO_ADUANEIRO', 'operadorAduaneiro', true);
    };
    /**
     * @return {?}
     */
    UnidadeSegmentoEnum.DISTRIBUIDOR = /**
     * @return {?}
     */
    function () {
        return new UnidadeSegmentoEnum('DISTRIBUIDOR', 'distribuidor', false);
    };
    /**
     * @return {?}
     */
    UnidadeSegmentoEnum.INDUSTRIA = /**
     * @return {?}
     */
    function () {
        return new UnidadeSegmentoEnum('INDUSTRIA', 'industria', false);
    };
    /**
     * @return {?}
     */
    UnidadeSegmentoEnum.VAREJO = /**
     * @return {?}
     */
    function () {
        return new UnidadeSegmentoEnum('VAREJO', 'varejo', true);
    };
    UnidadeSegmentoEnum.values = [
        UnidadeSegmentoEnum.OPERADOR_LOGISTICO(),
        UnidadeSegmentoEnum.RECINTO_ADUANEIRO(),
        UnidadeSegmentoEnum.DISTRIBUIDOR(),
        UnidadeSegmentoEnum.INDUSTRIA(),
        UnidadeSegmentoEnum.VAREJO()
    ];
    return UnidadeSegmentoEnum;
}(Enum));
if (false) {
    /** @type {?} */
    UnidadeSegmentoEnum.values;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var Unidade = /** @class */ (function () {
    function Unidade() {
    }
    return Unidade;
}());
if (false) {
    /** @type {?} */
    Unidade.prototype.nome;
    /** @type {?} */
    Unidade.prototype.segmento;
    /** @type {?} */
    Unidade.prototype.cnpj;
    /** @type {?} */
    Unidade.prototype.unidadeFederativa;
    /** @type {?} */
    Unidade.prototype.inscricaoEstadual;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function IUnidadeIncluirControle() { }
if (false) {
    /** @type {?} */
    IUnidadeIncluirControle.prototype.name;
    /** @type {?} */
    IUnidadeIncluirControle.prototype.validators;
    /** @type {?} */
    IUnidadeIncluirControle.prototype.get;
    /** @type {?} */
    IUnidadeIncluirControle.prototype.value;
    /** @type {?} */
    IUnidadeIncluirControle.prototype.withError;
}
/**
 * @record
 */
function IUnidadeIncluirControles() { }
if (false) {
    /** @type {?} */
    IUnidadeIncluirControles.prototype.nome;
    /** @type {?} */
    IUnidadeIncluirControles.prototype.segmento;
    /** @type {?} */
    IUnidadeIncluirControles.prototype.cnpj;
    /** @type {?} */
    IUnidadeIncluirControles.prototype.unidadeFederativa;
    /** @type {?} */
    IUnidadeIncluirControles.prototype.inscricaoEstadual;
}
var UnidadeIncluirForm = /** @class */ (function () {
    function UnidadeIncluirForm(formBuilder) {
        var _this = this;
        this.formBuilder = formBuilder;
        this._controles = {
            nome: this.criarControle('nome', Validators.required),
            segmento: this.criarControle('segmento', Validators.required),
            cnpj: this.criarControle('cnpj', cnpjValidator()),
            unidadeFederativa: this.criarControle('unidadeFederativa'),
            inscricaoEstadual: this.criarControle('inscricaoEstadual', inscricaoEstadualValidator((/**
             * @return {?}
             */
            function () { return _this.controles.unidadeFederativa ? _this.controles.unidadeFederativa.value() : ''; })))
        };
        this._grupo = this.formBuilder.group(this.criarControles());
        this.utils = new FormUtils(this.grupo);
    }
    Object.defineProperty(UnidadeIncluirForm.prototype, "controles", {
        get: /**
         * @return {?}
         */
        function () {
            return this._controles;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeIncluirForm.prototype, "grupo", {
        get: /**
         * @return {?}
         */
        function () {
            return this._grupo;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} formBuilder
     * @return {?}
     */
    UnidadeIncluirForm.of = /**
     * @param {?} formBuilder
     * @return {?}
     */
    function (formBuilder) {
        return new UnidadeIncluirForm(formBuilder);
    };
    /**
     * @return {?}
     */
    UnidadeIncluirForm.prototype.formEstaValido = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var formValido = this.utils.executeFormValidation();
        return formValido && this.grupo.valid;
    };
    /**
     * @return {?}
     */
    UnidadeIncluirForm.prototype.getUnidadeIncluir = /**
     * @return {?}
     */
    function () {
        return {
            id: undefined,
            nome: this.controles.nome.value(),
            cnpj: this.controles.cnpj.value(),
            inscricaoEstadual: this.controles.inscricaoEstadual.value(),
            unidadeFederativa: this.controles.unidadeFederativa.value(),
            segmento: this.controles.segmento.value()
        };
    };
    /**
     * @private
     * @return {?}
     */
    UnidadeIncluirForm.prototype.criarControles = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var controles = {};
        for (var chave in this.controles) {
            if (this.controles.hasOwnProperty(chave)) {
                controles[chave] = [null, this.controles[chave].validators];
            }
        }
        return controles;
    };
    /**
     * @private
     * @param {?} nome
     * @param {...?} validadores
     * @return {?}
     */
    UnidadeIncluirForm.prototype.criarControle = /**
     * @private
     * @param {?} nome
     * @param {...?} validadores
     * @return {?}
     */
    function (nome) {
        var _this = this;
        var validadores = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            validadores[_i - 1] = arguments[_i];
        }
        return {
            name: nome,
            validators: validadores,
            get: (/**
             * @return {?}
             */
            function () { return _this.grupo ? _this.grupo.get(nome) : null; }),
            value: (/**
             * @return {?}
             */
            function () { return _this.grupo ? _this.grupo.get(nome).value : null; }),
            withError: (/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return (_this.grupo.get(nome).dirty && _this.grupo.get(nome).errors && _this.grupo.get(nome).errors[error]); })
        };
    };
    return UnidadeIncluirForm;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirForm.prototype._controles;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirForm.prototype._grupo;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirForm.prototype.utils;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirForm.prototype.formBuilder;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UnidadeIncluirComponent = /** @class */ (function () {
    function UnidadeIncluirComponent(global, formBuilder, router, activatedRoute, unidadeIncluirService) {
        var _this = this;
        this.global = global;
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.unidadeIncluirService = unidadeIncluirService;
        this.esconderBotaoCancelar = false;
        this.rotaAposAcoes = './../';
        this._acoesPagina = [];
        this._opcoesEstado = opcoesUFThfCombo();
        this._opcoesSegmento = UnidadeSegmentoEnum.values.map((/**
         * @param {?} segmento
         * @return {?}
         */
        function (segmento) { return segmento.toSelect(_this.global); }));
        this._form = UnidadeIncluirForm.of(formBuilder);
    }
    Object.defineProperty(UnidadeIncluirComponent.prototype, "acoesPagina", {
        get: /**
         * @return {?}
         */
        function () {
            return this._acoesPagina;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeIncluirComponent.prototype, "itensBreadcrumb", {
        get: /**
         * @return {?}
         */
        function () {
            return this._itensBreadcrumb;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeIncluirComponent.prototype, "form", {
        get: /**
         * @return {?}
         */
        function () {
            return this._form;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeIncluirComponent.prototype, "opcoesEstado", {
        get: /**
         * @return {?}
         */
        function () {
            return this._opcoesEstado;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(UnidadeIncluirComponent.prototype, "opcoesSegmento", {
        get: /**
         * @return {?}
         */
        function () {
            return this._opcoesSegmento;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    UnidadeIncluirComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.definirAcoesPagina();
    };
    /**
     * @param {?} uf
     * @return {?}
     */
    UnidadeIncluirComponent.prototype.alterarUnidadeFederativa = /**
     * @param {?} uf
     * @return {?}
     */
    function (uf) {
        var _this = this;
        if (uf) {
            this.form.controles.inscricaoEstadual.get().reset();
            setTimeout((/**
             * @return {?}
             */
            function () {
                _this.inscricaoEstadual.focus();
            }), 50);
        }
    };
    /**
     * @return {?}
     */
    UnidadeIncluirComponent.prototype.definirAcoesPagina = /**
     * @return {?}
     */
    function () {
        this._acoesPagina = [
            {
                label: this.global.i18n.literals.salvar,
                action: this.salvar.bind(this)
            }
        ];
        if (!this.esconderBotaoCancelar) {
            this._acoesPagina.push({
                label: this.global.i18n.literals.cancelar,
                action: this.cancelar.bind(this)
            });
        }
    };
    /**
     * @return {?}
     */
    UnidadeIncluirComponent.prototype.salvar = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.form.formEstaValido()) {
            this.global.loading.executeWithLoading((/**
             * @return {?}
             */
            function () { return _this.unidadeIncluirService.Post(_this.form.getUnidadeIncluir()); })).pipe(concatMap((/**
             * @return {?}
             */
            function () { return of(null).pipe(delay(250)); }))).subscribe((/**
             * @return {?}
             */
            function () {
                _this.global.msg.showMessage(new BaseMessage({
                    literal: 'unidadeIncluidaSucesso'
                }).withMessageType(ShowMessageType.NotificationSuccess));
                _this.voltar();
            }), (/**
             * @param {?} error
             * @return {?}
             */
            function (error) {
                console.error(error);
            }));
        }
    };
    /**
     * @return {?}
     */
    UnidadeIncluirComponent.prototype.cancelar = /**
     * @return {?}
     */
    function () {
        this.voltar();
    };
    /**
     * @private
     * @return {?}
     */
    UnidadeIncluirComponent.prototype.voltar = /**
     * @private
     * @return {?}
     */
    function () {
        this.router.navigate([this.rotaAposAcoes], {
            relativeTo: this.activatedRoute
        });
    };
    UnidadeIncluirComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lib-unidade-incluir',
                    template: "<po-page-default\n  [p-title]=\"global.i18n.literals['novaUnidade']\"\n  [p-actions]=\"acoesPagina\"\n  [p-breadcrumb]=\"itensBreadcrumb\">\n\n  <form \n    [formGroup]=\"form.grupo\"\n    class=\"po-row\">\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-input\n        [name]=\"form.controles.nome.name\"\n        [formControlName]=\"form.controles.nome.name\"\n        [p-label]=\"global.i18n.literals['nome']\"\n        [p-placeholder]=\"global.i18n.literals['informeNome']\"\n        p-focus>\n      </po-input>\n      <p\n        [hidden]=\"!form.controles.nome.withError('required')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['informeNome'] }}\n      </p>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-select\n        [name]=\"form.controles.segmento.name\"\n        [formControlName]=\"form.controles.segmento.name\"\n        [p-label]=\"global.i18n.literals['segmento']\"\n        [p-placeholder]=\"global.i18n.literals['selecioneSegmento']\"\n        [p-options]=\"opcoesSegmento\">\n      </po-select>\n      <p\n        [hidden]=\"!form.controles.segmento.withError('required')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['selecioneSegmento'] }}\n      </p>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-input\n        [name]=\"form.controles.cnpj.name\"\n        [formControlName]=\"form.controles.cnpj.name\"\n        [p-label]=\"global.i18n.literals['cnpj']\"\n        [p-placeholder]=\"global.i18n.literals['informeNumero']\"\n        p-mask=\"99.999.999/9999-99\"\n        p-optional>\n      </po-input>\n      <p\n        [hidden]=\"!form.controles.cnpj.withError('cnpjInvalido')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['cnpjInvalido'] }}\n      </p>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-select\n        [name]=\"form.controles.unidadeFederativa.name\"\n        [formControlName]=\"form.controles.unidadeFederativa.name\"\n        [p-label]=\"global.i18n.literals['estado']\"\n        [p-placeholder]=\"global.i18n.literals['selecioneEstado']\"\n        [p-options]=\"opcoesEstado\"\n        p-optional\n        (p-change)=\"alterarUnidadeFederativa($event)\">\n      </po-select>\n    </div>\n\n    <div class=\"po-sm-12 po-md-6 po-lg-3 po-xl-3\">\n      <po-input\n        #inscricaoEstadual\n        [name]=\"form.controles.inscricaoEstadual.name\"\n        [formControlName]=\"form.controles.inscricaoEstadual.name\"\n        [p-label]=\"this.global.i18n.literals['inscricaoEstadual']\"\n        [p-placeholder]=\"this.global.i18n.literals['informeNumero']\"\n        [p-disabled]=\"!form.controles.unidadeFederativa.value()\"\n        p-mask=\"999999999999999\"\n        p-optional>\n      </po-input>\n      <p\n        [hidden]=\"!form.controles.inscricaoEstadual.withError('inscricaoEstadualInvalido')\"\n        class=\"po-mb-1 po-sm-12 po-md-12 po-lg-12 po-xl-12 po-text-color-07 po-font-text-small sem-padding-left\">\n        ! {{ global.i18n.literals['ieInvalido'] }}\n      </p>\n    </div>\n  </form>\n</po-page-default>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    UnidadeIncluirComponent.ctorParameters = function () { return [
        { type: GlobalService },
        { type: FormBuilder },
        { type: Router },
        { type: ActivatedRoute },
        { type: UnidadeIncluirService }
    ]; };
    UnidadeIncluirComponent.propDecorators = {
        esconderBotaoCancelar: [{ type: Input }],
        rotaAposAcoes: [{ type: Input }],
        inscricaoEstadual: [{ type: ViewChild, args: ['inscricaoEstadual', { static: true },] }]
    };
    return UnidadeIncluirComponent;
}());
if (false) {
    /** @type {?} */
    UnidadeIncluirComponent.prototype.esconderBotaoCancelar;
    /** @type {?} */
    UnidadeIncluirComponent.prototype.rotaAposAcoes;
    /** @type {?} */
    UnidadeIncluirComponent.prototype.inscricaoEstadual;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._acoesPagina;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._itensBreadcrumb;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._form;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._opcoesEstado;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype._opcoesSegmento;
    /** @type {?} */
    UnidadeIncluirComponent.prototype.global;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype.router;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    UnidadeIncluirComponent.prototype.unidadeIncluirService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var UnidadeIncluirModule = /** @class */ (function () {
    function UnidadeIncluirModule() {
    }
    UnidadeIncluirModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        UnidadeIncluirComponent
                    ],
                    imports: [
                        CommonModule,
                        AuthModule,
                        FndModule,
                        FormsModule,
                        ReactiveFormsModule,
                        PoPageModule,
                        PoFieldModule
                    ],
                    exports: [
                        UnidadeIncluirComponent
                    ]
                },] }
    ];
    return UnidadeIncluirModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { Unidade, UnidadeIncluirComponent, UnidadeIncluirForm, UnidadeIncluirModule, UnidadeSegmentoEnum };
//# sourceMappingURL=totvs-log-web-foundation-src-sl-unidade.js.map
