import { BaseMessage, ITextMessage } from 'totvs-log-base-foundation';
import { EventEmitter } from '@angular/core';
import { PoModalComponent, PoModalAction } from '@portinari/portinari-ui';
import { GlobalService } from '../../services/global/global.service';
export declare class MessageWithWarningComponent {
    global: GlobalService;
    /** Evento disparado na confirmação da operação na modal */
    confirm: EventEmitter<boolean>;
    /** Evento disparado no cancelamento da operação na modal */
    cancel: EventEmitter<boolean>;
    /** Mensagem que será apresentada */
    private _message;
    /** Método acessor que retorna a mensagem que deve ser apresentada */
    readonly message: ITextMessage;
    /** Tamanho da janela que será apresentada para o usuário. */
    private _modalSize;
    /** Método acessor que retorna o tamanho da janela que será apresentada para o usuário */
    readonly modalSize: string;
    /** Variável que indica se o fechamento da modal é controlado manualmente pelo programador */
    private closeManually;
    /** Ação primária Confirmar */
    private _primaryAction;
    readonly primaryAction: PoModalAction;
    /** Ação secundária Cancelar */
    private _secondaryAction;
    readonly secondaryAction: PoModalAction;
    /** Referência para a modal */
    modal: PoModalComponent;
    constructor(global: GlobalService);
    /**
     * Define a ação secundária para a modal
     */
    private setSecondaryAction;
    /**
     * Define a ação primária para a modal
     */
    private setPrimaryAction;
    /**
     * Abre a modal com a mensagem
     * @param message Mensagem que pode ser passada com strings ou literais
     * @param closeManually Indicação se o controle do fechamento da modal deve ser manual
     * (programador precisa disparar o comando nos eventos de confirmação/cancelamento)
     */
    open(message: BaseMessage | ITextMessage, closeManually?: boolean, modalSize?: string): void;
}
