import { AbstractControl, FormBuilder, FormGroup, ValidationErrors } from '@angular/forms';
import { IUnidade } from 'totvs-log-base-foundation/src/sl-unidade';
interface IUnidadeIncluirControle {
    name: string;
    validators: ValidationErrors[];
    get: () => AbstractControl;
    value: () => string;
    withError: (error: string) => boolean;
}
interface IUnidadeIncluirControles {
    nome: IUnidadeIncluirControle;
    segmento: IUnidadeIncluirControle;
    cnpj: IUnidadeIncluirControle;
    unidadeFederativa: IUnidadeIncluirControle;
    inscricaoEstadual: IUnidadeIncluirControle;
}
export declare class UnidadeIncluirForm {
    private readonly formBuilder;
    private _controles;
    readonly controles: IUnidadeIncluirControles;
    private _grupo;
    readonly grupo: FormGroup;
    private utils;
    static of(formBuilder: FormBuilder): UnidadeIncluirForm;
    private constructor();
    formEstaValido(): boolean;
    getUnidadeIncluir(): IUnidade;
    private criarControles;
    private criarControle;
}
export {};
